---
created_at: '2015-11-26T19:52:40.000Z'
title: Real Programming in Functional Languages (1982) [pdf]
url: http://research.microsoft.com/en-us/um/people/simonpj/Papers/other-authors/morris-real-programming.pdf
author: luu
points: 49
story_text: 
comment_text: 
num_comments: 10
story_id: 
story_title: 
story_url: 
parent_id: 
created_at_i: 1448567560
_tags:
- story
- author_luu
- story_10634435
objectID: '10634435'

---
[Source](https://www.microsoft.com/en-us/research/people/simonpj/?from=http%3A%2F%2Fresearch.microsoft.com%2Fen-us%2Fum%2Fpeople%2Fsimonpj%2Fpapers%2Fother-authors%2Fmorris-real-programming.pdf "Permalink to Simon Peyton Jones at Microsoft Research")

# Simon Peyton Jones at Microsoft Research

Try Microsoft Edge A fast and secure browser that's designed for Windows 10 No thanks Get started

This site uses cookies for analytics, personalized content and ads. By continuing to browse this site, you agree to this use. [Learn more][1]

[ ![][2] Microsoft ][3]

Research

* [Microsoft 365][4]
* [Azure][5]
* [Office 365][6]
* [Dynamics 365][7]
* [SQL][8]
* [Windows 10][9]
* More
    * Products & Services
        * [Windows Server][10]
        * [Enterprise Mobility + Security][11]
        * [Power BI][12]
        * [Teams][13]
        * [Visual Studio][14]
        * [Surface for Business][15]
    * Emerging Technologies
        * [AI][16]
        * [Internet of Things][17]
        * [Azure Cognitive Services][18]
        * [Quantum][19]
        * [Research][20]
    * Developer & IT
        * [Docs][21]
        * [TechNet][22]
        * [Developer Network][23]
        * [Windows Dev Center][24]
        * [Windows IT Pro Center][25]
        * [FastTrack][26]
    * Partner
        * [Partner Network][27]
        * [Solution Providers][28]
        * [Partner Center][29]
        * [Cloud Hosting][30]
    * Industries
        * [Education][31]
        * [Financial services][32]
        * [Government][33]
        * [Health][34]
        * [Manufacturing & resources][35]
        * [Retail][36]
    * Other
        * [Security][37]
        * [Licensing][38]
        * [AppSource][39]
        * [Azure Marketplace][40]
        * [Events][41]
    * [View all][42]

[ Research ][43] [Research Home][43]

Research areas

* Intelligence
    * [Artificial Intelligence][44]
    * [Computer vision][45]
    * [Graphics & multimedia][46]
    * [Human-computer interaction][47]
    * [Human language technologies][48]
    * [Search & information retrieval][49]
* Systems
    * [Data visualization, analytics & platform][50]
    * [Hardware, devices & quantum computing][51]
    * [Programming languages & software engineering][52]
    * [Security, privacy & cryptography][53]
    * [Systems & networking][54]
* Theory
    * [Algorithms][55]
    * [Mathematics][56]
* Other Sciences
    * [Ecology & environment][57]
    * [Economics][58]
    * [Medical, health & genomics][59]
    * [Social sciences][60]
    * [Technology for emerging markets][61]

[Products & Downloads][62]

Programs & Events

* [Academic Programs][63]
* [Events & Conferences][64]

[People][65] [Careers][66]

Blogs & Podcasts

* [Microsoft Research Blog][67]
* [The Microsoft Research Podcast][68]
* [The AI Blog][69]

Labs & Locations

* Microsoft Research
    * [MSR AI][70]
    * [Asia Lab (Chinese)][71]
    * [Asia Lab (English)][72]
    * [Cambridge Lab][73]
    * [India Lab][74]
    * [Montreal Lab][75]
    * [New England Lab][76]
    * [New York City Lab][77]
    * [Redmond Lab][78]
* Other labs/locations
    * [Applied Sciences Lab][79]
    * [Advanced Technology Lab Cairo][80]
    * [Quantum][81]
* About
    * [Research at Microsoft][82]

![Portrait of Simon Peyton Jones][83]

# Simon Peyton Jones

Principal Researcher

## Contact Info

### Telephone

[+44 1223 479 848][84]

###  [ Email ][85]

21 Station Road  
Cambridge, CB1 2FB  
United Kingdom

## Groups

* [Programming Principles and Tools][86]
* [About][87]
* [Publications][88]
* [Videos][89]
* [Pictures][90]
* [Awards & Honours][91]
* [Biography][92]

## About

I'm a researcher at Microsoft Research in Cambridge, England. I started here in Sept 1998. I'm also an Honorary Professor of the [Computing Science Department][93] at [Glasgow University][94], where I was a professor during 1990-1998.

I am married to Dorothy, a priest in the Church of England. We have six children.

I'm interested in the design, implementation, and application of lazy functional languages. In practical terms, that means I spend a most of my time on the design and implementation of [the language Haskell][95]. In particular, much of my work is focused around [the Glasgow Haskell Compiler][96], and its ramifications.

I am chair of [Computing at School][97], the group at the epicentre of the reform of the national curriculum for Computing in England.   Computer science is now a foundational subject, alongside maths and natural science, that every child learns from primary school onwards ([background here][98]).

####  Research skills 

* [How to write a great research paper][99]
* [How to give a great research talk][100]
* [How to write a great grant proposal][101]

####  Useful information and links 

* [The Computing at School Working Group][102]
* A 2014 Microsoft [blog post about CAS and computing education][103]
* [My Win32 cheat sheet][104]
* My GPG key fingerprint is: CABA 2C32 0D13 B715 8611 0390 6B2B 1815 5F25 C538

####  Haskell stuff 

* The [International Conference on Functional Programming][105]
* [The Revised Haskell 98 Report][106]
* [The main Haskell home page][95]
* [The Glasgow Haskell Compiler][107]
* Johan Tibell’s [State of Haskell 2010 ][108]questionnaire results
* [John Hughes’s links to tutorials on functional programming][109]
* [A History of Haskell: being lazy with class][110].
* [Tackling the awkward squad: monadic input/output, concurrency, exceptions, and foreign-language calls in Haskell][111].
* [Type classes: exploring the design space][112]
* [Wearing the hair shirt: a retrospective on Haskell][113]. Slides of my invited talk at POPL’03
* [A taste of Haskell][114]. Video and slides from my tutorial on Haskell at the O’Reilly Open Source Convention in Portland, 2007
* [The main Haskell mailing list][115]

####  Social networks 

I use LinkedIn for professional networking, but I restrict my connections to people who I know personally, or with whom I have had some meaningful two-way professional interaction; that is, not simply people with whom I share a professional interest.

I use Facebook for non-work networking, but only for people who my family knows too.

I do have a Twitter account, for some reason, but I have yet to find something significant enough to say that it’s worth tweeting.

In all three cases my actual use is minimal, so don’t hold your breath.

## Publications

![][116]

## Videos

![][116]

## Other

A collection of pictures of me, at various resolutions. There is also, for amusement, picture of [me having fun][117], taken by John Peterson.

* ![Very low resolution][118] :  Very low resolution 
* ![Very low resolution][119] :  Very low resolution 
* ![High resolution 2016][120] :  High resolution 2016 
* ![High resolution 2016][121] :  High resolution 2016 

  

* ![High resolution 2016][122] :  High resolution 2016 
* ![High resolution 2016][123] :  High resolution 2016 
* ![High resolution 2016][124] :  High resolution 2016 
* ![High resolution 2013-14][125] :  High resolution 2013-14 

  

* ![High resolution 2013-14][126] :  High resolution 2013-14 
* ![High resolution 2013-14][127] :  High resolution 2013-14 
* ![High resolution 2013-14][128] :  High resolution 2013-14 
* ![High resolution 2013-14][129] :  High resolution 2013-14 

  

* ![High resolution 2013-14][130] :  High resolution 2013-14 
* ![High resolution 2013-14][131] :  High resolution 2013-14 
* ![High resolution 2013-14][132] :  High resolution 2013-14 
* ![High resolution 2006][133] :  High resolution 2006 

  

* ![High resolution 2006][134] :  High resolution 2006 
* ![High resolution 2006][135] :  High resolution 2006 
* ![High resolution 2006][136] :  High resolution 2006 
* ![Medium resolution very old][137] :  Medium resolution very old 

  

* ![Medium resolution very old][138] :  Medium resolution very old 
* ![Medium resolution very old][139] :  Medium resolution very old 
* ![Medium resolution very old][140] :  Medium resolution very old 
* ![Medium resolution very old][141] :  Medium resolution very old 

  

* ![Medium resolution very old][142] :  Medium resolution very old 
* ![Medium resolution very old][143] :  Medium resolution very old 
* ![Medium resolution very old][144] :  Medium resolution very old 
* ![Medium resolution very old][145] :  Medium resolution very old 

  

* ![Medium resolution very old][146] :  Medium resolution very old 
* ![Medium resolution very old][147] :  Medium resolution very old 
* ![Medium resolution very old][148] :  Medium resolution very old 
* ![Medium resolution very old][149] :  Medium resolution very old 

  

 

## Awards & Honours

### Fellowships

* [Fellow of the Royal Society][150] (2016)
* [Distinguished Fellow of the BCS][151] (2017)
* [Fellow of the ACM][152] (2004)

 

### I am honoured to have received the following honorary degrees:

* [Honorary DSc from the University of Glasgow][153] (2013); Muffy Calder’s [oration][154]
* [Honorary DEd from the University of Bath][155] (2017); Chris Budd’s [oration][155]; [video][156]
* [Honorary DSc from the University of Kent, Canterbury][157] (2017)
* [Honorary DSc from the Queen Mary University of London][158] (2017)

 

### Awards

* The 2016 [ACM SIGPLAN Programming Languages Achievement Award][159]
* The 2016 [ACM SIGPLAN Most Influential ICFP Paper Award][160] (shared with [Dimitrios Vytiniotis][161], Stephanie Weirich, and Geoffrey Washburn)
* The 2015 [ACM SIGPLAN Most Influential ICFP Paper Award][160] (shared with Manuel M. T. Chakravarty and Gabriele Keller)
* The 2014 [ACM SIGPLAN Distinguished Service Award][162]
* The 2014 [ACM SIGPLAN Most Influential ICFP Paper Award][160] (shared with Ralf Lämmel)
* The 2011 [ACM SIGPLAN Programming Languages Software Award][163] (shared with Simon Marlow)
* The 2003 [ACM SIGPLAN Most Influential POPL Paper Award][164] (shared with Philip Wadler)

## Biography

A brief biography, suitable for seminar announcements and suchlike

Simon Peyton Jones, FRS, graduated from Trinity College Cambridge in 1980. After two years in industry, he spent seven years as a lecturer at University College London, and nine years as a professor at Glasgow University, before moving to Microsoft Research (Cambridge) in 1998.

Simon’s main research interest is in functional programming languages, their implementation, and their application. He was a key contributor to the design of the now-standard functional language Haskell, and is the lead designer of the widely-used [Glasgow Haskell Compiler][96] (GHC). He has written two textbooks about the implementation of functional languages.  He is particularly motivated by direct application of principled theory to practical language design and implementation — that is one reason he loves functional programming so much.

Simon is chair of [Computing at School][102], the grass-roots organisation that was at the epicentre of the 2014 reform of the English computing curriculum.

##  Follow Microsoft Research 

* * [Follow @MSFTResearch][165]
* ##  Share this page 
* * [Tweet][166]
* #### What's new
* [Surface Book 2][167]
* [Surface Pro][168]
* [Xbox One X][169]
* [Xbox One S][170]
* [VR & mixed reality][171]
* [Windows 10 apps][172]
* [Office apps][173]

#### Store & Support

* [Account profile][174]
* [Download Center][175]
* [Sales & support][176]
* [Returns][177]
* [Order tracking][178]
* [Store locations][179]
* [Support][180]
* [Buy online, pick up in store][181]

#### Education

* [Microsoft in education][31]
* [Office for students][182]
* [Office 365 for schools][183]
* [Deals for students & educators ][184]
* [Microsoft Azure in education][185]

#### Enterprise

* [Microsoft Azure ][186]
* [Enterprise][187]
* [Data platform][188]
* [Find a solutions provider][189]
* [Microsoft partner resources ][190]
* [Microsoft AppSource ][191]
* [Manufacturing & resources][35]
* [Financial services][32]

#### Developer

* [Microsoft Visual Studio][14]
* [Windows Dev Center][24]
* [Developer Network][23]
* [TechNet][192]
* [Microsoft Virtual Academy][193]
* [Microsoft developer program][194]
* [Channel 9][195]
* [Office Dev Center][196]

#### Company

* [Careers][197]
* [About Microsoft][198]
* [Company news][199]
* [Privacy at Microsoft][200]
* [Investors][201]
* [Diversity and inclusion][202]
* [Accessibility][203]
* [Security][204]
* [Sitemap][205]
* [Contact us][206]
* [Privacy & cookies ][207]
* [Terms of use][208]
* [Trademarks][209]
* [About our ads][210]
* © Microsoft 2018

![][211]

[1]: https://go.microsoft.com/fwlink/?linkid=845480
[2]: https://img-prod-cms-rt-microsoft-com.akamaized.net/cms/api/am/imageFileData/RE1Mu3b?ver=5c31
[3]: https://www.microsoft.com
[4]: https://www.microsoft.com/en-us/microsoft-365
[5]: https://azure.microsoft.com
[6]: https://products.office.com/en-us/business/office
[7]: https://dynamics.microsoft.com/en-us/
[8]: https://www.microsoft.com/sql-server/
[9]: https://www.microsoft.com/en-us/windowsforbusiness
[10]: https://www.microsoft.com/cloud-platform/windows-server
[11]: https://www.microsoft.com/cloud-platform/enterprise-mobility-security
[12]: https://powerbi.microsoft.com/en-us/
[13]: https://products.office.com/en-us/microsoft-teams/group-chat-software
[14]: https://www.visualstudio.com/
[15]: https://www.microsoft.com/en-us/surface/business/overview
[16]: https://www.microsoft.com/ai/
[17]: https://www.microsoft.com/internet-of-things
[18]: https://azure.microsoft.com/services/cognitive-services/
[19]: https://www.microsoft.com/quantum/
[20]: https://www.microsoft.com/research/
[21]: https://docs.microsoft.com/en-us/
[22]: https://technet.microsoft.com/en-us/ms376608.aspx
[23]: https://msdn.microsoft.com/en-us
[24]: https://developer.microsoft.com/en-us/windows
[25]: https://www.microsoft.com/en-us/itpro/windows
[26]: https://fasttrack.microsoft.com/office
[27]: https://partner.microsoft.com/
[28]: https://www.microsoft.com/solution-providers/
[29]: https://partnercenter.microsoft.com/partner/home
[30]: https://www.microsoft.com/en-us/cloudandhosting
[31]: https://www.microsoft.com/en-us/education
[32]: https://enterprise.microsoft.com/en-us
[33]: https://enterprise.microsoft.com/en-us/industries/government/
[34]: https://enterprise.microsoft.com/en-us/industries/health/
[35]: https://enterprise.microsoft.com/en-us/industries/discrete-manufacturing/
[36]: https://enterprise.microsoft.com/en-us/industries/retail-and-consumer-goods/
[37]: https://www.microsoft.com/security/
[38]: https://www.microsoft.com/licensing/
[39]: https://appsource.microsoft.com/
[40]: https://azuremarketplace.microsoft.com/marketplace/
[41]: https://events.microsoft.com/
[42]: https://www.microsoft.com/en-us/sitemap.aspx
[43]: https://www.microsoft.com/en-us/research/
[44]: https://www.microsoft.com/en-us/research/research-area/artificial-intelligence/
[45]: https://www.microsoft.com/en-us/research/research-area/computer-vision/
[46]: https://www.microsoft.com/en-us/research/research-area/graphics-and-multimedia/
[47]: https://www.microsoft.com/en-us/research/research-area/human-computer-interaction/
[48]: https://www.microsoft.com/en-us/research/research-area/human-language-technologies/
[49]: https://www.microsoft.com/en-us/research/research-area/search-information-retrieval/
[50]: https://www.microsoft.com/en-us/research/research-area/data-visualization-analytics-platform/
[51]: https://www.microsoft.com/en-us/research/research-area/hardware-devices-quantum-computing/
[52]: https://www.microsoft.com/en-us/research/research-area/programming-languages-software-engineering/
[53]: https://www.microsoft.com/en-us/research/research-area/security-privacy-cryptography/
[54]: https://www.microsoft.com/en-us/research/research-area/systems-and-networking/
[55]: https://www.microsoft.com/en-us/research/research-area/algorithms/
[56]: https://www.microsoft.com/en-us/research/research-area/computational-sciences-mathematics/
[57]: https://www.microsoft.com/en-us/research/research-area/ecology-environment/
[58]: https://www.microsoft.com/en-us/research/research-area/economics/
[59]: https://www.microsoft.com/en-us/research/research-area/medical-health-genomics/
[60]: https://www.microsoft.com/en-us/research/research-area/social-sciences/
[61]: https://www.microsoft.com/en-us/research/research-area/technology-for-emerging-markets/
[62]: https://www.microsoft.com/en-us/research/products/
[63]: https://www.microsoft.com/en-us/research/academic-programs/
[64]: https://www.microsoft.com/en-us/research/events-conferences/
[65]: https://www.microsoft.com/en-us/research/people/
[66]: https://www.microsoft.com/en-us/research/careers/
[67]: https://www.microsoft.com/en-us/research/blog
[68]: https://www.microsoft.com/en-us/research/blog/category/podcast/
[69]: https://blogs.microsoft.com/next/
[70]: https://www.microsoft.com/en-us/research/lab/microsoft-research-ai/
[71]: http://www.msra.cn
[72]: https://www.microsoft.com/en-us/research/lab/microsoft-research-asia/
[73]: https://www.microsoft.com/en-us/research/lab/microsoft-research-cambridge/
[74]: https://www.microsoft.com/en-us/research/lab/microsoft-research-india/
[75]: https://www.microsoft.com/en-us/research/lab/microsoft-research-montreal/
[76]: https://www.microsoft.com/en-us/research/lab/microsoft-research-new-england/
[77]: https://www.microsoft.com/en-us/research/lab/microsoft-research-new-york/
[78]: https://www.microsoft.com/en-us/research/lab/microsoft-research-redmond/
[79]: https://www.microsoft.com/en-us/research/lab/applied-sciences-group/
[80]: https://www.microsoft.com/en-us/research/group/advanced-technology-lab-cairo-2/
[81]: https://www.microsoft.com/en-us/research/lab/quantum/
[82]: https://www.microsoft.com/en-us/research/about/
[83]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/06/avatar_user__1465484273-180x180.jpg
[84]: tel:+44 1223 479 848
[85]: mailto:simonpj%40microsoft.com
[86]: https://www.microsoft.com/en-us/research/group/programming-principles-and-tools/
[87]: https://www.microsoft.com#%21about
[88]: https://www.microsoft.com#%21publications
[89]: https://www.microsoft.com#%21videos
[90]: https://www.microsoft.com#%21pictures
[91]: https://www.microsoft.com#%21awards-honours
[92]: https://www.microsoft.com#%21biography
[93]: http://www.dcs.gla.ac.uk/
[94]: http://www.gla.ac.uk/
[95]: http://www.haskell.org/
[96]: http://haskell.org/ghc
[97]: http://www.computingatschool.org.uk
[98]: http://community.computingatschool.org.uk/resources/3084
[99]: https://www.microsoft.com/en-us/research/academic-program/write-great-research-paper/
[100]: https://www.microsoft.com/en-us/research/academic-program/give-great-research-talk/
[101]: https://www.microsoft.com/en-us/research/academic-program/how-to-write-a-great-research-proposal/
[102]: http://www.computingatschool.org.uk/
[103]: https://www.microsoft.com/en-us/research/blog/from-grassroots-to-government/
[104]: https://www.microsoft.com/en-us/research/publication/win-32-cheat-sheet/
[105]: http://www.cs.luc.edu/icfp/
[106]: http://haskell.org/definition/
[107]: http://www.haskell.org/ghc/
[108]: http://blog.johantibell.com/2010/08/results-from-state-of-haskell-2010.html
[109]: http://www.md.chalmers.se/~rjmh/tutorials.html
[110]: https://www.microsoft.com/en-us/research/publication/a-history-of-haskell-being-lazy-with-class/
[111]: https://www.microsoft.com/en-us/research/publication/tackling-awkward-squad-monadic-inputoutput-concurrency-exceptions-foreign-language-calls-haskell/
[112]: https://www.microsoft.com/en-us/research/publication/type-classes-an-exploration-of-the-design-space/
[113]: https://www.microsoft.com/en-us/research/publication/wearing-hair-shirt-retrospective-haskell-2003/
[114]: https://www.microsoft.com/en-us/research/video/taste-haskell-part-1/
[115]: http://www.haskell.org//pipermail/haskell/
[116]: https://www.microsoft.com/en-us/research/wp-content/themes/microsoft-research-theme/images/loading.gif
[117]: https://www.flickr.com/photos/97222587@N07/sets/72157635145551707/
[118]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/spj-snow.jpg
[119]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/spjJun06-small-199x300.jpg
[120]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/DSC_9396_crop-300x198.jpg
[121]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/DSC_9401_crop-202x300.jpg
[122]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/DSC_9415_crop-300x193.jpg
[123]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/DSC_9447_crop-300x201.jpg
[124]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/DSC_9474_crop-198x300.jpg
[125]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/TEDx-Mar14-1-200x300.jpg
[126]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/TEDx-Mar14-2-200x300.jpg
[127]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/TEDx-Mar14-3-200x300.jpg
[128]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/SPJ-Jun13-2-200x300.jpg
[129]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/SPJ-Jun13-5-200x300.jpg
[130]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/SPJ-Jun13-7-200x300.jpg
[131]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/SPJ-Jun13-12-200x300.jpg
[132]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/SPJ-Jun13-15-200x300.jpg
[133]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/spjJun06.1-199x300.jpg
[134]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/spjJun06.2-199x300.jpg
[135]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/spjJun06.3-e1470732675195-199x300.jpg
[136]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/spjJun06.8-e1470732652301-199x300.jpg
[137]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/spj01-225x300.jpg
[138]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/spj02-300x214.jpg
[139]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/spj04-225x300.jpg
[140]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/spj05-300x225.jpg
[141]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/spj06-300x225.jpg
[142]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/spj07-300x225.jpg
[143]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/spj08-300x225.jpg
[144]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/spj09-225x300.jpg
[145]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/spj10-225x300.jpg
[146]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/spj11-225x300.jpg
[147]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/spj12-225x300.jpg
[148]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/spj13-212x300.jpg
[149]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/SPJJan01-300x225.jpg
[150]: https://royalsociety.org/people/simon-peyton-jones-12889/
[151]: http://www.bcs.org/content/ConWebDoc/57526
[152]: http://awards.acm.org/fellow/all.cfm
[153]: http://www.gla.ac.uk/schools/computing/news/newsitem/?id=23
[154]: http://www.dcs.gla.ac.uk/~muffy/SPJ_oration.pdf
[155]: http://www.bath.ac.uk/corporate-information/professor-simon-peyton-jones-oration/
[156]: https://vimeo.com/224453771
[157]: http://blogs.kent.ac.uk/unikentcomp-news/2017/07/24/simon-peyton-jones/
[158]: http://www.qmul.ac.uk/media/news/items/199065.html
[159]: http://www.sigplan.org/Awards/Achievement/
[160]: http://www.sigplan.org/Awards/ICFP/
[161]: https://www.microsoft.com/en-us/research/people/dimitris/
[162]: http://www.sigplan.org/Awards/Service/
[163]: http://www.sigplan.org/Awards/Software/
[164]: http://www.sigplan.org/Awards/POPL/
[165]: https://twitter.com/MSFTResearch
[166]: https://twitter.com/share
[167]: https://www.microsoft.com/en-us/surface/devices/surface-book-2/overview
[168]: https://www.microsoft.com/en-us/surface/devices/surface-pro/overview
[169]: https://www.xbox.com/en-us/xbox-one-x
[170]: https://www.xbox.com/en-us/xbox-one-s?xr=shellnav
[171]: https://www.microsoft.com/en-us/store/b/virtualreality
[172]: https://www.microsoft.com/en-us/windows/windows-10-apps
[173]: https://store.office.com/en-us/appshome.aspx?
[174]: https://account.microsoft.com/
[175]: https://www.microsoft.com/en-us/download
[176]: https://go.microsoft.com/fwlink/p/?LinkID=824761&clcid=0x409
[177]: https://go.microsoft.com/fwlink/p/?LinkID=824764&clcid=0x409
[178]: https://account.microsoft.com/orders
[179]: https://www.microsoft.com/en-us/store/locations/find-a-store
[180]: https://support.microsoft.com/en-us
[181]: https://www.microsoft.com/en-us/store/b/buy-online-pick-up-in-store?icid=uhf_footer_bopuis
[182]: https://www.microsoft.com/en-us/education/products/office/default.aspx
[183]: https://products.office.com/en-us/academic/compare-office-365-education-plans
[184]: https://www.microsoft.com/en-us/store/b/student
[185]: https://azure.microsoft.com/en-us/community/education/
[186]: https://azure.microsoft.com/
[187]: https://enterprise.microsoft.com/en-us/
[188]: https://www.microsoft.com/en-us/sql-server/
[189]: https://www.microsoft.com/en-us/solution-providers
[190]: https://partner.microsoft.com/en-us/
[191]: https://go.microsoft.com/fwlink/?LinkID=808093
[192]: https://technet.microsoft.com/en-us
[193]: https://mva.microsoft.com/
[194]: https://developer.microsoft.com/en-us/store/register
[195]: https://channel9.msdn.com/
[196]: https://developer.microsoft.com/office
[197]: https://careers.microsoft.com/
[198]: https://www.microsoft.com/en-us/about
[199]: https://news.microsoft.com/
[200]: https://privacy.microsoft.com/en-us
[201]: https://www.microsoft.com/investor/default.aspx
[202]: https://www.microsoft.com/en-us/diversity/
[203]: https://www.microsoft.com/en-us/accessibility/home
[204]: https://www.microsoft.com/en-us/security/default.aspx
[205]: https://www.microsoft.com/en-us/sitemap1.aspx
[206]: https://support.microsoft.com/en-us/contactus
[207]: https://go.microsoft.com/fwlink/?LinkId=521839
[208]: https://go.microsoft.com/fwlink/?LinkID=206977
[209]: https://www.microsoft.com/trademarks
[210]: https://choice.microsoft.com
[211]: https://www.facebook.com/tr?id=435868603227390&ev=PageView&noscript=1

